<template>
  <div id="Calendar">
    <calendar-sidebar
      :domains="domains"
      v-on:external-event-click="onEventClick"
    />
    <div class="calendar">
      <full-calendar class="full-calendar" :options="config">
        <template #eventContent="{ timeText, event }">
          <b>{{ timeText }}</b>
          <i>{{ event.title }}</i>
        </template>
      </full-calendar>
      <v-dialog v-model="taskDialog" width="80%">
        <taskCard
          :initial-task="dropedTask"
          @on-task-save="onExternalDropSave"
        />
      </v-dialog>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";
import { addHours, addDays } from "date-fns";

import FullCalendar from "@fullcalendar/vue";
import dayGridPlugin from "@fullcalendar/daygrid";
import timeGridPlugin from "@fullcalendar/timegrid";
import interactionPlugin from "@fullcalendar/interaction";
import listPlugin from "@fullcalendar/list";
import he from "@fullcalendar/core/locales/he";

import CalendarSidebar from "./CalendarSidebar.vue";
import taskCard from "./taskCard";

export default {
  components: {
    FullCalendar,
    CalendarSidebar,
    taskCard,
  },
  computed: {
    ...mapGetters(["filterTasks", "getTask"]),
    ...mapGetters("metadata", ["domains"]),

    config() {
      return {
        ...this.configOptions,
        ...this.eventHandlers,
      };
    },

    configOptions() {
      return {
        editable: true,
        droppable: true, // this allows things to be dropped onto the calendar
        dayMaxEvents: true,
        events: this.filterTasks,
        plugins: [dayGridPlugin, timeGridPlugin, interactionPlugin, listPlugin],
        headerToolbar: {
          right: "prev,next today",
          center: "title",
          left: "dayGridMonth,timeGridWeek,timeGridDay,listMonth",
        },
        initialView: "dayGridMonth",
        locale: he,
        contentHeight: "auto",
        // height: "auto",
      };
    },

    eventHandlers() {
      return {
        eventClick: this.onEventClick,
        eventDrop: this.onEventDrop,
        eventResize: this.onEventResize,
        select: this.onDateSelect,
        drop: this.onExternalDrop,
        eventReceive: this.eventReceive,
      };
    },
  },
  data: function() {
    return {
      taskDialog: false,
      dropedTask: {},
    };
  },
  methods: {
    ...mapActions("metadata", ["fetchMetadata"]),
    ...mapActions(["fetchAllTasks"]),
    ...mapActions("fatherTaskDialog/", ["onTaskClick"]),
    ...mapActions(["updateTask"]),
    onEventClick({ event }) {
      console.log(event);
      // this.onTaskClick(event.extendedProps.father_id);
      this.$root.$emit(
        "call-father-task-dialog",
        event.extendedProps.father_id
      );
    },
    onEventDrop({ event }) {
      let task = this.getTask(event.id);
      task.start = addHours(event._instance.range.start, -3);
      task.end = addHours(event._instance.range.end, -3);
      this.updateTask(task);
    },
    onEventResize({ event }) {
      let task = this.getTask(event.id);
      task.start = addHours(event._instance.range.start, -3);
      task.end = addHours(event._instance.range.end, -3);
      this.updateTask(task);
    },
    // onExternalDrop(dropInfo) {
    //   console.log(dropInfo);
    //   // const id = dropInfo.draggedEl.id;
    //   // const start = dropInfo.date;
    //   // const allDay = dropInfo.allDay;
    //   // let task = this.getTask(id);
    //   // task.start = start;
    //   // if (allDay) {
    //   //   task.end = addDays(start, 1);
    //   // } else {
    //   //   task.end = addHours(start, 1);
    //   // }
    //   // this.dropedTask = task;
    //   // this.taskDialog = true;
    // },
    onExternalDropSave(task) {
      this.taskDialog = false;
      this.updateTask(task);
    },
    eventReceive(info) {
      info.revert();
      let task = Object.assign({}, this.getTask(info.draggedEl.id));
      task.start = addHours(info.event._instance.range.start, -3);
      task.end = addHours(info.event._instance.range.end, -3);
      this.dropedTask = task;
      this.taskDialog = true;
    },
  },
  created: function() {
    this.fetchAllTasks();
    this.fetchMetadata();
  },
  // watch: {
  //   taskDialog(val) {
  //     if (!val) {
  //       console.log(this.dropedTask);
  //     }
  //   },
  // },
};
</script>

<style>
* {
  padding: 0;
  margin: 0;
  box-sizing: border-box;
}

html,
body {
  height: 100vh;
}

body {
  font-family: Arial, Helvetica Neue, Helvetica, sans-serif;
  font-size: 14px;
}
</style>

<style scoped>
#Calendar {
  display: flex;
  overflow: hidden;
}

.calendar {
  flex: 1;

  padding: 2em;
}
</style>
